package kr.pe.nowonbun.household2.browser;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.Hashtable;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import javax.websocket.EncodeException;

import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

import kr.pe.nowonbun.household2.bean.Household_Category;
import kr.pe.nowonbun.household2.common.HAjaxController;
import kr.pe.nowonbun.household2.common.HWSParams;
import kr.pe.nowonbun.household2.dao.CategoryDao;
import kr.pe.nowonbun.household2.dao.HouseholdDao;
import kr.pe.nowonbun.household2.entity.Category;
import kr.pe.nowonbun.household2.entity.Household;

@Controller
public class HBListSearch extends HAjaxController{

	@Override
	protected Class<?> setLogclass() {
		return HBListSearch.class;
	}
	@RequestMapping(value="/browser/listSearch.html",method=RequestMethod.POST)
	@ResponseBody
	public String ListSearch(ModelMap modelmap,HttpSession session,HttpServletRequest req,HttpServletResponse res,String message)
		throws Exception{
		initSession(modelmap,session,req,res);
		HWSParams input = decode(message);
		SimpleDateFormat s = new SimpleDateFormat("yyyy-MM");
		/*
		 * 検索AJAX
		 */
		if(input == null){
			throw new NullPointerException("Function Type Null Exception");
		}
		logger().info("Browser Ajax Search ID -" + getUerInfoSession().getUserid());
		logger().info("Function Code - "+ input.getFunc());
		if("search".equals(input.getFunc())){
			HouseholdDao householddao = new HouseholdDao();
			CategoryDao categorydao = new CategoryDao();
			Calendar c = Calendar.getInstance();
			c.setTime(s.parse(input.getData().toString()));
			Calendar c1 = Calendar.getInstance();
			Calendar c2 = Calendar.getInstance();
			
			c1.clear();
			c2.clear();
			
			c1.set(Calendar.YEAR,c.get(Calendar.YEAR));
			c1.set(Calendar.MONTH,c.get(Calendar.MONTH));
			c1.set(Calendar.DATE, 1);
		
			c2.set(Calendar.YEAR,c.get(Calendar.YEAR));
			c2.set(Calendar.MONTH,c.get(Calendar.MONTH));
			c2.set(Calendar.DATE, 1);
			c2.add(Calendar.MONTH, 1);
			c2.add(Calendar.DATE, -1);
			
			logger().info("household Type - " + getUerInfoSession().getHouseholdtype());
			logger().info("startDate - " + c1.getTime());
			logger().info("endDate - " + c2.getTime());
			List<Household> list = null;
			List<Category> categorylist = null;
			try{
				list = householddao.findList(new Object[]{
										HouseholdDao.DEFAULTLIST,
										getUerInfoSession().getHouseholdtype(),
										c1.getTime(),
										c2.getTime()});
				categorylist = categorydao.findList(new Object[]{
										CategoryDao.ALLLIST,
										getUerInfoSession().getHouseholdtype()});
				logger().info("Search count - "+list.size());
			}catch(Exception e){
				logger().error("household list Searching error!");
				throw e;
			}
			List<Household_Category> list2 = new ArrayList<Household_Category>();
			for (Household item : list) {
				Household_Category data = new Household_Category();
				data.setData(item);
				if(data.getCategory() != null){
					for(Category item2 : categorylist){
						if(item2.getIdx().equals(data.getCategory().intValue())){
							data.setCategoryname(item2.getCategoryname());
							data.setCategorystate(item2.getState());
							break;
						}
					}
				}
				list2.add(data);
			}
			try{
				setReturnFunc(input.getFunc());
				//setReturnData(list);
				setReturnData(list2);
				logger().info("Search OK! ");
				return encode(getReturnParams());
			}catch(EncodeException e){
				logger().error("send Error Exception - " + e);
				throw e;
			}
		}else if("insert".equals(input.getFunc())){
			String data1 = input.getData().toString();
			logger().info("insert message - " + data1);
			Household data = (Household)processMessage(data1, Household.class);
			
			HouseholdDao dao = new HouseholdDao();
			Hashtable<String, Object> ret = new Hashtable<String, Object>();
			try{
				if(validate(data)){
					dao.TransactionBegin();
					Integer idx = data.getIdx();
					if(idx != null){
						logger().info("MODIFY!!!");
						Household entity = dao.findByPk(idx);
						Household backup = copyEntity(entity);
						if(!entity.getHouseholdtype().equals(getUerInfoSession().getHouseholdtype())){
							throw new Exception("householdType Bind Error!");
						}
						backup.setIdx(null);
						backup.setState("1");
						dao.create(backup);
						
						logger().info("backup data idx - "+data.getIdx());
						entity.setHouseholddate(data.getHouseholddate());
						entity.setMoneytype(data.getMoneytype());
						entity.setCategory(data.getCategory());
						entity.setContents(data.getContents());
						entity.setMoney(data.getMoney());
						entity.setOther(data.getOther());
						entity.setCreater(getUerInfoSession().getUserid());
						entity.setCreatedate(new Date());
						dao.update(entity);
						logger().info("data modify idx - " + entity.getIdx());
						dao.TransactionCommit();
						logger().info("MODIFY OK!");
						ret.put("result", "success");
						ret.put("idx", data.getIdx());
					}else{
						logger().info("Addcation!!!");
						data.setState("0");
						if(data.getCategory() == null){
							data.setCategory(0l);
						}
						data.setHouseholdtype(getUerInfoSession().getHouseholdtype());
						data.setCreater(getUerInfoSession().getUserid());
						data.setCreatedate(new Date());
						dao.create(data);
						logger().info("data addcation idx - " + data.getIdx());
						dao.TransactionCommit();
						logger().info("Insert OK!");
						ret.put("result", "success");
						ret.put("idx", data.getIdx());
					}
				}else{
					logger().error("Household data validate error!");
					logger().error("householdDate - "+data.getHouseholddate());
					logger().error("moneyType - "+data.getMoneytype());
					logger().error("contents - "+data.getContents());
					logger().error("money - "+data.getMoney());
					logger().error("other - "+data.getOther());
					logger().error("householdType - "+data.getHouseholdtype());
					logger().error("Category - "+data.getCategory());
					ret.put("result", "failed");
				}
			}catch(Exception e){
				dao.TransactionRollBack();
				logger().error("data update error - "+e);
				ret.put("result", "failed");
			}
			try{
				setReturnFunc(input.getFunc());
				setReturnData(ret);
				return encode(getReturnParams());
			}catch(EncodeException e){
				logger().error("send Error Exception - " + e);
				throw e;
			}
		}else if("delete".equals(input.getFunc())){
			String data1 = input.getData().toString();
			logger().info("delete message - "+data1);
			Household data = (Household)processMessage(data1, Household.class);
			
			HouseholdDao dao = new HouseholdDao();
			Hashtable<String, Object> ret = new Hashtable<String, Object>();
			
			try{
				dao.TransactionBegin();
				data = dao.findByPk(data.getIdx());
				if(!data.getHouseholdtype().equals(getUerInfoSession().getHouseholdtype())){
					throw new Exception("householdType Bind Error!");
				}
				data.setState("1");
				dao.update(data);
				logger().info("data delete idx - "+data.getIdx());
				dao.TransactionCommit();
				ret.put("result", "success");
			}catch(Exception e){
				dao.TransactionRollBack();
				logger().error("data delete error - "+e);
				ret.put("result", "failed");
			}
			try{
				setReturnFunc(input.getFunc());
				setReturnData(ret);
				return encode(getReturnParams());
			}catch(EncodeException e){
				logger().error("send Error Exception - " + e);
				throw e;
			}
		}else if("categorySearch".equals(input.getFunc())){
			CategoryDao dao = new CategoryDao();
			try{
				List<Category> categorylist = dao.findList(new Object[]{	CategoryDao.DEFAULTLIST,
	 					getUerInfoSession().getHouseholdtype()});
				logger().info("CategorySearch count - "+categorylist.size());
				setReturnFunc(input.getFunc());
				setReturnData(categorylist);
				return encode(getReturnParams());
			}catch(Exception e){
				logger().error("category Search Error - " + e);
				throw e;
			}
		}else if("categoryUpdate".equals(input.getFunc())){
			String data1 = input.getData().toString();
			logger().info("Category Update message - "+data1);
			
			Category data = (Category)processMessage(data1, Category.class);
			
			CategoryDao dao = new CategoryDao();
			Hashtable<String, Object> ret = new Hashtable<String, Object>();
			try{
				dao.TransactionBegin();
				Integer idx = data.getIdx();
				if(idx != null){
					Category entity = dao.findByPk(idx);
					if(!entity.getHouseholdtype().equals(getUerInfoSession().getHouseholdtype())){
						throw new Exception("householdType Bind Error!");
					}
					entity.setState("1");
					dao.update(entity);
					logger().info("category modify idx - "+data.getIdx());
					data.setIdx(null);
				}
				data.setState("0");
				data.setCreatedate(new Date());
				data.setCreater(getUerInfoSession().getUserid());
				data.setHouseholdtype(getUerInfoSession().getHouseholdtype());
				dao.create(data);				
				dao.TransactionCommit();
				ret.put("result", "success");
			}catch(Exception e){
				dao.TransactionRollBack();
				logger().error("data update error - "+e);
				ret.put("result", "failed");
			}
			try{
				setReturnFunc(input.getFunc());
				setReturnData(ret);
				return encode(getReturnParams());
			}catch(EncodeException e){
				logger().error("send Error Exception - " + e);
				throw e;
			}			
		}else if("categoryDelete".equals(input.getFunc())){
			String data1 = input.getData().toString();
			logger().info("Category Delete message - "+data1);
			
			Category data = (Category)processMessage(data1, Category.class);
			
			CategoryDao dao = new CategoryDao();
			Hashtable<String, Object> ret = new Hashtable<String, Object>();
			try{
				dao.TransactionBegin();
				data = dao.findByPk(data.getIdx());
				if(!data.getHouseholdtype().equals(getUerInfoSession().getHouseholdtype())){
					throw new Exception("householdType Bind Error!");
				}
				data.setState("1");
				dao.update(data);
				logger().info("data delete idx - "+ data.getIdx());
				dao.TransactionCommit();
				ret.put("result", "success");				
			}catch(Exception e){
				dao.TransactionRollBack();
				logger().error("data update error - "+e);
				ret.put("result", "failed");
			}
			try{
				setReturnFunc(input.getFunc());
				setReturnData(ret);
				return encode(getReturnParams());
			}catch(EncodeException e){
				logger().error("send Error Exception - " + e);
				throw e;
			}	
		}
		throw new Exception("message funcion name wrong!");
	}
	protected boolean validate(Household household){
		logger().info("validate Check - "+household.getIdx());
		if(household.getHouseholddate() == null){
			logger().error("HouseholdDate null");
			return false;
		}else if(household.getMoneytype() == null || "".equals(household.getMoneytype())){
			logger().error("MoneyType null");
			return false;
		}else if(household.getContents() == null || "".equals(household.getContents())){
			logger().error("Contents null");
			return false;
		}else if(household.getMoney() == null){
			logger().error("Money null");
			return false;
		}else if(household.getHouseholdtype() == null){
			//return false;
		}else if(household.getCategory() == null){
			logger().error("Category null");
			return false;
		}
		return true;
	}
	protected Household copyEntity(Household original){
		Household ret = new Household();
		ret.setIdx(null);
		ret.setHouseholddate(original.getHouseholddate());
		ret.setMoneytype(original.getMoneytype());
		ret.setCategory(original.getCategory());
		ret.setContents(original.getContents());
		ret.setMoney(original.getMoney());
		ret.setOther(original.getOther());
		ret.setCreater(original.getCreater());
		ret.setCreatedate(original.getCreatedate());
		ret.setHouseholdtype(original.getHouseholdtype());
		ret.setState(original.getState());
		return ret;
	}
}
