package kr.pe.nowonbun.household2.browser;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

import kr.pe.nowonbun.household2.common.HController;
import kr.pe.nowonbun.household2.dao.UsertableDao;
import kr.pe.nowonbun.household2.entity.Usertable;

@Controller
public class HBLogin extends HController{
	@Override
	protected Class<?> setLogclass() {
		return HBLogin.class;
	}
	@RequestMapping(value="/browser/login.html",method=RequestMethod.GET)
	public String LoginIndex(ModelMap modelmap,HttpSession session,HttpServletRequest req,HttpServletResponse res){
		logger().info("Web browser's login page is opening.");
		initSession(modelmap,session,req,res);
		if(getUerInfoSession() != null){
			logger().info("session is lived. id - " + getUerInfoSession().getUserid());
			createConnectLog(getUerInfoSession().getUserid());
			return "redirect:main.html";
		}
		logger().info("Loggin Page open");
		return "/browser/login";
	}
	@RequestMapping(value="/browser/login.html",method=RequestMethod.POST)
	public String LoginSubmit(ModelMap modelmap,HttpSession session,HttpServletRequest req,HttpServletResponse res,Usertable usertable){
		logger().info("Web browser's login authentication is starting.");
		initSession(modelmap,session,req,res);
		
		UsertableDao dao = new UsertableDao();
		String userid = usertable.getUserid();
		logger().info("Web browser's login ID - "+userid);
		usertable = dao.passwordCheck(usertable);
		if(usertable != null){
			logger().info("Web browser's login OK.");
			setUserInfoSession(usertable);
			createConnectLog(userid);
			return "redirect:main.html";
		}else{
			logger().info("Web browser's login NG.");
			modelmap.addAttribute("userid", userid);
			modelmap.addAttribute("errorMsg", "IDまたはパスワードをご確認してください。");
			return "/browser/login";
		}
	}
	@RequestMapping(value="/browser/logout.html")
	public String Logout(ModelMap modelmap,HttpSession session,HttpServletRequest req,HttpServletResponse res){
		logger().info("Web browser's logout. ID - "+getUerInfoSession().getUserid());
		initSession(modelmap,session,req,res);
		getSession().invalidate();
		return "redirect:login.html";
	}
}
