package kr.pe.nowonbun.household2.browser;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.RequestMapping;

import kr.pe.nowonbun.household2.common.HController;
import kr.pe.nowonbun.household2.dao.CategoryDao;
import kr.pe.nowonbun.household2.dao.ConnectlogDao;
import kr.pe.nowonbun.household2.entity.Category;
import kr.pe.nowonbun.household2.entity.Connectlog;

@Controller
public class HBMain extends HController{

	@Override
	protected Class<?> setLogclass() {
		return HBMain.class;
	}
	
	@RequestMapping(value="/browser/main.html")
	public String MainIndex(ModelMap modelmap,HttpSession session,HttpServletRequest req,HttpServletResponse res)
		throws Exception{
		initSession(modelmap,session,req,res);
		logger().info("household Type - " + getUerInfoSession().getHouseholdtype());
		CategoryDao dao = new CategoryDao();
		ConnectlogDao dao2 = new ConnectlogDao();
		List<Category> categorylist = null;
		List<Category> incomeCategory = new ArrayList<Category>();
		List<Category> exportCategory = new ArrayList<Category>();
		try {
			categorylist = dao.findList(new Object[]{	CategoryDao.DEFAULTLIST,
					 					getUerInfoSession().getHouseholdtype()});
			for(Category category : categorylist){
				if("1".equals(category.getMoneytype())){
					incomeCategory.add(category);
				}else if("2".equals(category.getMoneytype())){
					exportCategory.add(category);
				}
			}
			List<Connectlog> connectLog = dao2.findList(
						new Object[]{ConnectlogDao.LASTCONNECTIONTIME,getUerInfoSession().getUserid()});
			if(connectLog.size() >= 2){
				Date time = new Date(connectLog.get(1).getConntecttime().getTime());
				SimpleDateFormat s = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
				modelmap.addAttribute("connectlog",s.format(time));
			}else{
				modelmap.addAttribute("connectlog","-");
			}
			Calendar c = Calendar.getInstance();
			if(req.getParameter("year") != null && req.getParameter("month") != null){
				try{
					SimpleDateFormat s = new SimpleDateFormat("yyyyMMdd");
					int year = Integer.parseInt(req.getParameter("year"));
					int month = Integer.parseInt(req.getParameter("month"));
					c.setTime(s.parse(String.format("%04d%02d01", year,month)));
				}catch(Exception e){
					logger().error("parameter error");
					logger().error("year : "+req.getParameter("year"));
					logger().error("month : "+req.getParameter("month"));
					c.setTime(new Date());
				}
			}else{
				c.setTime(new Date());
			}
			modelmap.addAttribute("year",String.format("%04d",c.get(Calendar.YEAR)));
			modelmap.addAttribute("month",String.format("%02d",c.get(Calendar.MONTH)+1));
			modelmap.addAttribute("incomeCategory",incomeCategory);
			modelmap.addAttribute("exportCategory",exportCategory);
			
		} catch (Exception e) {
			logger().error("search Error - "+e);
			throw e;
		}
		
		return "/browser/main";
	}
}
