package kr.pe.nowonbun.household2.common;

import java.sql.Timestamp;
import java.util.Calendar;
import java.util.Date;

import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.ui.ModelMap;

import kr.pe.nowonbun.household2.dao.ConnectlogDao;
import kr.pe.nowonbun.household2.entity.Connectlog;
import kr.pe.nowonbun.household2.entity.Usertable;

public abstract class HController {
	private static Logger logger = null;
	public final static String USERINFO = "unserInfo";
	private HttpSession session;
	private HttpServletRequest request;
	private HttpServletResponse response;
	private ModelMap modelmap;
	public HController(){
		logger = LoggerFactory.getLogger(setLogclass());
	}
	protected abstract Class<?> setLogclass();
	protected void initSession(ModelMap modelmap,HttpSession session,HttpServletRequest request,HttpServletResponse response){
		setModelmap(modelmap);
		setSession(session);
		setRequest(request);
		setResponse(response);
	}
	public ModelMap getModelmap() {
		return modelmap;
	}
	public void setModelmap(ModelMap modelmap) {
		this.modelmap = modelmap;
	}
	protected HttpServletRequest getRequest() {
		return request;
	}
	protected void setRequest(HttpServletRequest request) {
		this.request = request;
	}
	protected HttpServletResponse getResponse() {
		return response;
	}
	protected void setResponse(HttpServletResponse response) {
		this.response = response;
	}
	protected HttpSession getSession() {
		return session;
	}
	protected void setSession(HttpSession session) {
		this.session = session;
	}
	protected void setUserInfoSession(Usertable userinfo){
		session.setAttribute(USERINFO, userinfo);
	}
	protected Usertable getUerInfoSession(){
		return (Usertable)session.getAttribute(USERINFO);
	}
	protected Logger logger(){
		return logger;
	}
	protected void createConnectLog(String userid){
		Date date = new Date();
		logger().info(userid + " is connection time : "+ date);
		Connectlog entity = new Connectlog();
		entity.setUserid(userid);
		entity.setConntecttime(new Timestamp(date.getTime()));
		ConnectlogDao dao2 = new ConnectlogDao();
		try{
			dao2.TransactionBegin();
			dao2.create(entity);
			dao2.TransactionCommit();
		}catch(Exception e){
			logger().error("connectionlog write error - "+e);
			dao2.TransactionRollBack();
		}
	}
	protected void setCookie(String name,String value,int time){
		Cookie cookie = new Cookie(name,value);
		cookie.setMaxAge(time);
		cookie.setPath("/");
		response.addCookie(cookie);
	}
}
