package kr.pe.nowonbun.household2.common;

import java.io.IOException;

import javax.servlet.http.HttpSession;
import javax.websocket.EncodeException;
import javax.websocket.EndpointConfig;
import javax.websocket.Session;

import kr.pe.nowonbun.household2.entity.Usertable;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.fasterxml.jackson.core.JsonParseException;
import com.fasterxml.jackson.databind.JsonMappingException;
import com.fasterxml.jackson.databind.ObjectMapper;

public abstract class HWebsocket {
	
	private static Logger logger = null;
	private HttpSession httpSession;
	private Session socketSession;
	public HWebsocket(){
		logger = LoggerFactory.getLogger(setLogclass());
	}
	protected abstract Class<?> setLogclass();
	protected Logger logger(){
		return logger;
	}
	protected HttpSession getHttpSession() {
		return httpSession;
	}
	protected void setHttpSession(HttpSession httpSession) {
		this.httpSession = httpSession;
	}
	protected void setHttpSession(EndpointConfig conf) {
		this.httpSession = (HttpSession) conf.getUserProperties().get(HttpSession.class.getName());
	}
	protected Usertable getUerInfoSession(){
		return (Usertable)httpSession.getAttribute(HController.USERINFO);
	}
	protected Object processMessage(String param,Class<?> type){
		ObjectMapper mapper = new ObjectMapper();
		try {
			return mapper.readValue(param, type);
		} catch (JsonParseException e) {
			logger().error("mapping error e -" + e);
			return null;
		} catch (JsonMappingException e) {
			logger().error("mapping error e -" + e);
			return null;
		} catch (IOException e) {
			logger().error("mapping error e -" + e);
			return null;
		}
	}
	protected void setSocketSession(Session session){
		socketSession = session;
	}
	protected void sendMessage(String func,Object data) 
			throws EncodeException,IOException{
		HWSParams output = new HWSParams();
		output.setFunc(func);
		output.setData(data);
		socketSession.getBasicRemote().sendObject(output);
	}
}
