package kr.pe.nowonbun.household2.dao;

import java.sql.SQLException;

import javax.persistence.Query;
import javax.persistence.TypedQuery;

import kr.pe.nowonbun.household2.common.HDao;
import kr.pe.nowonbun.household2.entity.Category;

public class CategoryDao extends HDao<Category, Integer>{

	public final static String DEFAULTLIST = "Defaultlist";
	public final static String ALLLIST = "Alllist";
	
	@Override
	protected Class<?> setLogclass() {
		return CategoryDao.class;
	}

	@Override
	protected Class<Category> getEntityClass() {
		return Category.class;
	}

	@Override
	protected String getQueryString(Object[] params) throws Exception {
		if(params.length < 1 || params[0] == null) {
			logger().error("[function : getQueryString]parameter is null - index : 0");
			throw new SQLException("parameter Error!");
		}
		String type = params[0].toString();
		if(DEFAULTLIST.equals(type)){
			return "SELECT c FROM Category c WHERE c.state=:state and c.householdtype=:householdtype order by c.idx";
		}else if(ALLLIST.equals(type)){
			return "SELECT c FROM Category c WHERE c.householdtype=:householdtype order by c.idx";
		}
		logger().error("[function : getQueryString]parameter error!");
		return null;
	}

	@Override
	protected void setQueryParams(TypedQuery<Category> query, Object[] params)
			throws Exception {
		if(params.length < 1 || params[0] == null) {
			logger().error("[function : setQueryParams]parameter is null - index : 0");
			throw new SQLException("parameter Error!");
		}
		String type = params[0].toString();
		if(DEFAULTLIST.equals(type)){
			if(params.length < 2) {
				logger().error("[function : setQueryParams]parameter is null - index : 1,2");
				throw new SQLException("parameter Error!");
			}
			try{
				query.setParameter("state", "0");
				query.setParameter("householdtype", params[1]);
			}catch(Exception e){
				logger().error("[function : setQueryParams]parameter type wrong");
				throw e;
			}
		}else if(ALLLIST.equals(type)){
			try{
				query.setParameter("householdtype", params[1]);
			}catch(Exception e){
				logger().error("[function : setQueryParams]parameter type wrong");
				throw e;
			}
		}else{
			logger().error("[function : setQueryParams]parameter error!");
		}
	}

	@Override
	protected String getNativeQueryString(Object[] params) {
		throw new UnsupportedOperationException();
	}

	@Override
	protected void setNativeQueryParams(Query query, Object[] params) {
		// TODO Auto-generated method stub
		
	}

	@Override
	protected String getUpdateQueryString(Object[] params) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected String getNativeUpdateQueryString(Object[] params) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected void setNativeUpdateQueryParams(Query query, Object[] params) {
		// TODO Auto-generated method stub
		
	}

	@Override
	protected String getDeleteQueryString(Object[] params) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected void setDeleteQueryParams(TypedQuery<Category> query,
			Object[] params) {
		// TODO Auto-generated method stub
		
	}

	@Override
	protected String getNativeDeleteQueryString(Object[] params) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected void setNativeDeleteQueryParams(Query query, Object[] params) {
		// TODO Auto-generated method stub
		
	}

	@Override
	protected String getInsertQueryString(Object[] params) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected void setInsertQueryParams(TypedQuery<Category> query,
			Object[] params) {
		// TODO Auto-generated method stub
		
	}

	@Override
	protected String getNativeInsertQueryString(Object[] params) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected void setNativeInsertQueryParams(Query query, Object[] params) {
		// TODO Auto-generated method stub
		
	}

}
