package kr.pe.nowonbun.household2.dao;

import java.sql.SQLException;

import javax.persistence.Query;
import javax.persistence.TypedQuery;

import kr.pe.nowonbun.household2.common.HDao;
import kr.pe.nowonbun.household2.entity.Connectlog;

public class ConnectlogDao extends HDao<Connectlog, String>{

	public final static String LASTCONNECTIONTIME = "LastConnectionTime";
	@Override
	protected Class<?> setLogclass() {
		return ConnectlogDao.class;
	}

	@Override
	protected Class<Connectlog> getEntityClass() {
		return Connectlog.class;
	}

	@Override
	protected String getQueryString(Object[] params) throws Exception {
		if(params.length < 1 || params[0] == null) {
			logger().error("[function : getQueryString]parameter is null - index : 0");
			throw new SQLException("parameter Error!");
		}
		String type = params[0].toString();
		if(LASTCONNECTIONTIME.equals(type)){
			return "SELECT c FROM Connectlog c where c.userid=:userid order by c.conntecttime desc";
		}
		return null;
	}

	@Override
	protected void setQueryParams(TypedQuery<Connectlog> query, Object[] params)
			throws Exception {
		if(params.length < 1 || params[0] == null) {
			logger().error("[function : setQueryParams]parameter is null - index : 0");
			throw new SQLException("parameter Error!");
		}
		String type = params[0].toString();
		if(LASTCONNECTIONTIME.equals(type)){
			if(params.length < 2) {
				logger().error("[function : setQueryParams]parameter is null - index : 1,2");
				throw new SQLException("parameter Error!");
			}
			try{
				query.setMaxResults(2);
				query.setParameter("userid", params[1]);
			}catch(Exception e){
				logger().error("[function : setQueryParams]parameter type wrong");
				throw e;
			}
		}
		else{
			logger().error("[function : setQueryParams]parameter error!");
		}
	}

	@Override
	protected String getNativeQueryString(Object[] params) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected void setNativeQueryParams(Query query, Object[] params) {
		// TODO Auto-generated method stub
		
	}

	@Override
	protected String getUpdateQueryString(Object[] params) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected String getNativeUpdateQueryString(Object[] params) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected void setNativeUpdateQueryParams(Query query, Object[] params) {
		// TODO Auto-generated method stub
		
	}

	@Override
	protected String getDeleteQueryString(Object[] params) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected void setDeleteQueryParams(TypedQuery<Connectlog> query,
			Object[] params) {
		// TODO Auto-generated method stub
		
	}

	@Override
	protected String getNativeDeleteQueryString(Object[] params) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected void setNativeDeleteQueryParams(Query query, Object[] params) {
		// TODO Auto-generated method stub
		
	}

	@Override
	protected String getInsertQueryString(Object[] params) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected void setInsertQueryParams(TypedQuery<Connectlog> query,
			Object[] params) {
		// TODO Auto-generated method stub
		
	}

	@Override
	protected String getNativeInsertQueryString(Object[] params) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected void setNativeInsertQueryParams(Query query, Object[] params) {
		// TODO Auto-generated method stub
		
	}

}
