package kr.pe.nowonbun.household2.dao;

import java.sql.SQLException;

import javax.persistence.Query;
import javax.persistence.TypedQuery;

import kr.pe.nowonbun.household2.common.HDao;
import kr.pe.nowonbun.household2.entity.Household;

public class HouseholdDao extends HDao<Household, Integer>{

	public final static String DEFAULTLIST = "Defaultlist";
	public final static String DAYORDERLIST = "DayOrderlist";
	public final static String CATGORYLIST = "CategoryOrderlist";
	@Override
	protected Class<?> setLogclass() {
		return HouseholdDao.class;
	}

	@Override
	protected Class<Household> getEntityClass() {
		return Household.class;
	}

	@Override
	protected String getQueryString(Object[] params) 
			throws SQLException{
		if(params.length < 1 || params[0] == null) {
			logger().error("[function : getQueryString]parameter is null - index : 0");
			throw new SQLException("parameter Error!");
		}
		String type = params[0].toString();
		if(DEFAULTLIST.equals(type)){
			return "SELECT h FROM Household h where h.state=:state "
					+ "and h.householdtype=:householdtype "
					+ "and h.householddate between :householddatestart and :householddateend "
					+ "order by h.householddate desc,h.idx asc";
		}else if(DAYORDERLIST.equals(type)){
			return "SELECT h FROM Household h where h.state=:state "
					+ "and h.householdtype=:householdtype "
					+ "and h.householddate between :householddatestart and :householddateend "
					+ "order by h.householddate desc,h.idx asc";
		}else if(CATGORYLIST.equals(type)){
			return "SELECT h FROM Household h where h.state=:state "
					+ "and h.householdtype=:householdtype "
					+ "and h.householddate between :householddatestart and :householddateend "
					+ "order by h.category desc,h.householddate desc,h.idx asc";
		}
		logger().error("[function : getQueryString]parameter error!");
		return null;
	}

	@Override
	protected void setQueryParams(TypedQuery<Household> query, Object[] params)
		throws Exception{
		if(params.length < 1 || params[0] == null) {
			logger().error("[function : setQueryParams]parameter is null - index : 0");
			throw new SQLException("parameter Error!");
		}
		String type = params[0].toString();
		if(DEFAULTLIST.equals(type)){
			if(params.length < 3) {
				logger().error("[function : setQueryParams]parameter is null - index : 1,2");
				throw new SQLException("parameter Error!");
			}
			try{
				query.setParameter("state", "0");
				query.setParameter("householdtype", params[1]);
				query.setParameter("householddatestart", params[2]);
				query.setParameter("householddateend", params[3]);
			}catch(Exception e){
				logger().error("[function : setQueryParams]parameter type wrong");
				throw e;
			}
		}else if(DAYORDERLIST.equals(type)){
			if(params.length < 3) {
				logger().error("[function : setQueryParams]parameter is null - index : 1,2");
				throw new SQLException("parameter Error!");
			}
			try{
				query.setParameter("state", "0");
				query.setParameter("householdtype", params[1]);
				query.setParameter("householddatestart", params[2]);
				query.setParameter("householddateend", params[3]);
			}catch(Exception e){
				logger().error("[function : setQueryParams]parameter type wrong");
				throw e;
			}
		}else if(CATGORYLIST.equals(type)){
			if(params.length < 3) {
				logger().error("[function : setQueryParams]parameter is null - index : 1,2");
				throw new SQLException("parameter Error!");
			}
			try{
				query.setParameter("state", "0");
				query.setParameter("householdtype", params[1]);
				query.setParameter("householddatestart", params[2]);
				query.setParameter("householddateend", params[3]);
			}catch(Exception e){
				logger().error("[function : setQueryParams]parameter type wrong");
				throw e;
			}
		}
		else{
			logger().error("[function : setQueryParams]parameter error!");
		}
	}

	@Override
	protected String getNativeQueryString(Object[] params) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected void setNativeQueryParams(Query query, Object[] params) {
		// TODO Auto-generated method stub
		
	}

	@Override
	protected String getUpdateQueryString(Object[] params) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected String getNativeUpdateQueryString(Object[] params) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected void setNativeUpdateQueryParams(Query query, Object[] params) {
		// TODO Auto-generated method stub
		
	}

	@Override
	protected String getDeleteQueryString(Object[] params) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected void setDeleteQueryParams(TypedQuery<Household> query,
			Object[] params) {
		// TODO Auto-generated method stub
		
	}

	@Override
	protected String getNativeDeleteQueryString(Object[] params) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected void setNativeDeleteQueryParams(Query query, Object[] params) {
		// TODO Auto-generated method stub
		
	}

	@Override
	protected String getInsertQueryString(Object[] params) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected void setInsertQueryParams(TypedQuery<Household> query,
			Object[] params) {
		// TODO Auto-generated method stub
		
	}

	@Override
	protected String getNativeInsertQueryString(Object[] params) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected void setNativeInsertQueryParams(Query query, Object[] params) {
		// TODO Auto-generated method stub
		
	}

}
