package kr.pe.nowonbun.household2.mobile;

import java.util.Date;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

import kr.pe.nowonbun.household2.common.HController;
import kr.pe.nowonbun.household2.dao.CategoryDao;
import kr.pe.nowonbun.household2.entity.Category;

@Controller
public class HMCategoryInsert extends HController {
	@Override
	protected Class<?> setLogclass() {
		return HMCategoryInsert.class;
	}
	@RequestMapping(value="/mobile/categoryinsert.html",method=RequestMethod.GET)
	public String CategoryInsert(ModelMap modelmap,HttpSession session,HttpServletRequest req,HttpServletResponse res)
		throws Exception{
		initSession(modelmap,session,req,res);
		logger().info("カテゴリ登録画面開始");
		logger().info("household Type - " + getUerInfoSession().getHouseholdtype());
		return "/mobile/categoryinsert";
	}
	@RequestMapping(value="/mobile/categorymodify.html",method=RequestMethod.GET)
	public String CategoryModify(ModelMap modelmap,HttpSession session,HttpServletRequest req,HttpServletResponse res,Integer idx)
		throws Exception{
		initSession(modelmap,session,req,res);
		logger().info("カテゴリ修正画面開始");
		logger().info("カテゴリ　Index - "+idx);
		logger().info("household Type - " + getUerInfoSession().getHouseholdtype());
		CategoryDao dao = new CategoryDao();
		Category data = dao.findByPk(idx);
		if(getUerInfoSession().getHouseholdtype().equals(data.getHouseholdtype())){
			logger().info("category Index - "+data.getIdx());
			modelmap.addAttribute("categoryitem",data);
		}else{
			logger().error("家計簿タイプが一致しません。");
		}
		return "/mobile/categoryinsert";
	}
	@RequestMapping(value="/mobile/categoryinsert.html",method=RequestMethod.POST)
	public String CategoryInsert(ModelMap modelmap,HttpSession session,HttpServletRequest req,HttpServletResponse res,Category data)
		throws Exception{
		initSession(modelmap,session,req,res);
		logger().info("カテゴリ挿入開始");
		logger().info("household Type - " + getUerInfoSession().getHouseholdtype());
		
		if(data.getIdx().equals(0)){
			//生成
			data.setHouseholdtype(getUerInfoSession().getHouseholdtype());
			data.setCreater(getUerInfoSession().getUserid());
			data.setCreatedate(new Date());
			data.setState("0");
			CategoryDao dao = new CategoryDao();
			try{
				dao.TransactionBegin();
				dao.create(data);
				dao.TransactionCommit();
			}catch(Exception e){
				dao.TransactionRollBack();
				logger().error("カテゴリ生成中でエラーが発生しました。 e - " + e.toString());
			}
		}else{
			logger().error("インデクスがエラーになりました。- idx : "+ data.getIdx());	
		}
		return "redirect:categorylist.html";
	}
	@RequestMapping(value="/mobile/categorymodify.html",method=RequestMethod.POST)
	public String CategoryModify(ModelMap modelmap,HttpSession session,HttpServletRequest req,HttpServletResponse res,Category data)
		throws Exception{
		initSession(modelmap,session,req,res);
		logger().info("カテゴリ修正開始");
		logger().info("household Type - " + getUerInfoSession().getHouseholdtype());
		if(data == null){
			logger().error("データがNULL");
		}else{
			logger().info("カテゴリ Index - "+data.getIdx());
			Category backup = new Category();
			CategoryDao dao = new CategoryDao();
			String categoryName = data.getCategoryname();
			String moneyType = data.getMoneytype();
			data = dao.findByPk(data.getIdx());
			if(data.getHouseholdtype().equals(getUerInfoSession().getHouseholdtype())){	
				backup.setCategoryname(data.getCategoryname());
				backup.setMoneytype(data.getMoneytype());
				backup.setCreater(data.getCreater());
				backup.setCreatedate(data.getCreatedate());
				backup.setHouseholdtype(data.getHouseholdtype());
				backup.setState("1");
				data.setCategoryname(categoryName);
				data.setMoneytype(moneyType);
				data.setCreater(getUerInfoSession().getUserid());
				data.setCreatedate(new Date());
				try{
					dao.TransactionBegin();
					dao.update(data);
				}catch(Exception e){
					dao.TransactionRollBack();
					logger().error("カテゴリ修正中でエラーが発生しました。e -"+e.toString());
					return "redirect:categorylist.html";
				}
				logger().info("categoryName "+backup.getCategoryname()+" ---> "+categoryName);
				logger().info("moneyType "+backup.getMoneytype()+" ---> "+moneyType);
				try{
					dao.create(backup);
					dao.TransactionCommit();
				}catch(Exception e){
					dao.TransactionRollBack();
					logger().error("カテゴリ修正中でエラーが発生しました。e -"+e.toString());
					return "redirect:categorylist.html";
				}
			}else{
				logger().error("インデクスがエラーになりました。- idx : "+ data.getIdx());
			}
		}
		return "redirect:categorylist.html";
	}
	@RequestMapping(value="/mobile/categorydelete.html",method=RequestMethod.POST)
	public String CategoryDelete(ModelMap modelmap,HttpSession session,HttpServletRequest req,HttpServletResponse res,Category data)
		throws Exception{
		initSession(modelmap,session,req,res);
		logger().info("カテゴリ削除開始");
		logger().info("household Type - " + getUerInfoSession().getHouseholdtype());
		
		if(data == null){
			logger().error("データがNULL");
		}else{
			logger().info("カテゴリ Index - "+data.getIdx());
			CategoryDao dao = new CategoryDao();
			data = dao.findByPk(data.getIdx());
			if(data.getHouseholdtype().equals(getUerInfoSession().getHouseholdtype())){	
				data.setState("1");
				try{
					dao.TransactionBegin();
					dao.update(data);
					dao.TransactionCommit();
				}catch(Exception e){
					dao.TransactionRollBack();
					logger().error("カテゴリ削除中でエラーが発生しました。e -"+e.toString());
					return "redirect:categorylist.html";
				}
			}else{
				logger().error("インデクスがエラーになりました。- idx : "+ data.getIdx());
			}
		}
		return "redirect:categorylist.html";
	}
}
