package kr.pe.nowonbun.household2.mobile;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

import kr.pe.nowonbun.household2.common.HController;
import kr.pe.nowonbun.household2.dao.CategoryDao;
import kr.pe.nowonbun.household2.dao.HouseholdDao;
import kr.pe.nowonbun.household2.entity.Category;
import kr.pe.nowonbun.household2.entity.Household;

@Controller
public class HMInsert extends HController {

	@Override
	protected Class<?> setLogclass() {
		return HMInsert.class;
	}
	@RequestMapping(value="/mobile/insertform.html",method=RequestMethod.GET)
	public String InsertForm(ModelMap modelmap,HttpSession session,HttpServletRequest req,HttpServletResponse res)
		throws Exception{
		initSession(modelmap,session,req,res);
		logger().info("Mobile Inset Page Open!");
		logger().info("household Type - " + getUerInfoSession().getHouseholdtype());
		
		CategoryDao dao = new CategoryDao();
		List<Category> categorylist = null;
		List<Category> incomeCategory = new ArrayList<Category>();
		List<Category> exportCategory = new ArrayList<Category>();
		
		try {
			categorylist = dao.findList(new Object[]{	CategoryDao.ALLLIST,
					 					getUerInfoSession().getHouseholdtype()});
			for(Category category : categorylist){
				if("1".equals(category.getMoneytype())){
					incomeCategory.add(category);
				}else if("2".equals(category.getMoneytype())){
					exportCategory.add(category);
				}
			}
		} catch (Exception e) {
			logger().error("search Error - "+e);
			throw e;
		}		
		
		Calendar c = Calendar.getInstance();
		modelmap.addAttribute("year", c.get(Calendar.YEAR));
		modelmap.addAttribute("month", c.get(Calendar.MONTH)+1);
		modelmap.addAttribute("day", c.get(Calendar.DATE));
		
		modelmap.addAttribute("incomeCategory", incomeCategory);
		modelmap.addAttribute("exportCategory", exportCategory);
		
		return "/mobile/insertform";
	}
	@RequestMapping(value="/mobile/insertform.html",method=RequestMethod.POST)
	public String InsertForm(ModelMap modelmap,HttpSession session,HttpServletRequest req,HttpServletResponse res,Household household)
		throws Exception{
		initSession(modelmap,session,req,res);
		logger().info("Mobile Insert Page Submit!");
		logger().info("household Type - " + getUerInfoSession().getHouseholdtype());
		
		if("1".equals(household.getMoneytype())){
			try{
				household.setCategory(Long.parseLong(req.getParameter("incomecategoryList")));
			}catch(Exception e){
				logger().error("error - "+e.toString());
				throw e;
			}
		}else if("2".equals(household.getMoneytype())){
			try{
				household.setCategory(Long.parseLong(req.getParameter("expendcategoryList")));
			}catch(Exception e){
				logger().error("error - "+e.toString());
				throw e;
			}
		}else{
			logger().error("money typeが合わないです。");
			throw new Exception("money typeが合わないです。");
		}
		
		try{
			int year = Integer.parseInt(req.getParameter("year"));
			int month = Integer.parseInt(req.getParameter("month"));
			int day = Integer.parseInt(req.getParameter("day"));
			SimpleDateFormat s = new SimpleDateFormat("yyyy-MM-dd");
			Date householdDate = s.parse(String.format("%04d-%02d-%02d",year,month,day));
			household.setHouseholddate(householdDate);
			setCookie("date",String.format("%04d-%02d",year,month) ,365*24*60*60);
		}catch(Exception e){
			logger().error("date変換中でエラーが発生しました。");
			throw e;
		}
		if(household.getContents() == null || "".equals(household.getContents()) || household.getMoney() == null){
			throw new Exception("データ異常");
		}
		if(household.getCategory() == null){
			household.setCategory(0L);
		}
		household.setState("0");
		household.setHouseholdtype(getUerInfoSession().getHouseholdtype());
		household.setCreater(getUerInfoSession().getUserid());
		household.setCreatedate(new Date());
		
		HouseholdDao dao = new HouseholdDao();
		try{
			dao.TransactionBegin();
			dao.create(household);
			dao.TransactionCommit();
		}catch(Exception e){
			dao.TransactionRollBack();
			logger().error("家計簿入力エラー");
			throw e;
		}
		
		return "redirect:main.html";
	}
	@RequestMapping(value="/mobile/modifyform.html",method=RequestMethod.GET)
	public String ModifyForm(ModelMap modelmap,HttpSession session,HttpServletRequest req,HttpServletResponse res,Integer idx)
		throws Exception{
		initSession(modelmap,session,req,res);
		logger().info("Mobile Modify Page Submit!");
		logger().info("household Type - " + getUerInfoSession().getHouseholdtype());
		
		CategoryDao dao = new CategoryDao();
		List<Category> categorylist = null;
		List<Category> incomeCategory = new ArrayList<Category>();
		List<Category> exportCategory = new ArrayList<Category>();
		
		try {
			categorylist = dao.findList(new Object[]{	CategoryDao.ALLLIST,
					 					getUerInfoSession().getHouseholdtype()});
			for(Category category : categorylist){
				if("1".equals(category.getMoneytype())){
					incomeCategory.add(category);
				}else if("2".equals(category.getMoneytype())){
					exportCategory.add(category);
				}
			}
		} catch (Exception e) {
			logger().error("search Error - "+e);
			throw e;
		}		
	
		modelmap.addAttribute("incomeCategory", incomeCategory);
		modelmap.addAttribute("exportCategory", exportCategory);
		
		HouseholdDao dao2 = new HouseholdDao();
		Household household = dao2.findByPk(idx);
		if(!getUerInfoSession().getHouseholdtype().equals(household.getHouseholdtype())){
			throw new Exception("家計簿タイプが合わない。");
		}
		
		modelmap.addAttribute("household", household);
		Calendar c = Calendar.getInstance();
		c.setTime(household.getHouseholddate());
		modelmap.addAttribute("year", c.get(Calendar.YEAR));
		modelmap.addAttribute("month", c.get(Calendar.MONTH)+1);
		modelmap.addAttribute("day", c.get(Calendar.DATE));
		
		return "/mobile/insertform";
	}
	@RequestMapping(value="/mobile/modifyform.html",method=RequestMethod.POST)
	public String ModifyForm(ModelMap modelmap,HttpSession session,HttpServletRequest req,HttpServletResponse res,Household household)
		throws Exception{
		initSession(modelmap,session,req,res);
		logger().info("Mobile Modify Page Submit!");
		logger().info("household Type - " + getUerInfoSession().getHouseholdtype());
		
		HouseholdDao dao = new HouseholdDao();
		Household entity = dao.findByPk(household.getIdx());
		if(!getUerInfoSession().getHouseholdtype().equals(entity.getHouseholdtype())){
			throw new Exception("household type 間違い");
		}
		Household backup = copyEntity(entity);
		backup.setState("1");
		try{
			dao.TransactionBegin();
			dao.create(backup);
		}catch(Exception e){
			dao.TransactionRollBack();
			logger().error("家計簿入力エラー");
			throw e;
		}
		if("1".equals(household.getMoneytype())){
			try{
				household.setCategory(Long.parseLong(req.getParameter("incomecategoryList")));
			}catch(Exception e){
				logger().error("error - "+e.toString());
				dao.TransactionRollBack();
				throw e;
			}
		}else if("2".equals(household.getMoneytype())){
			try{
				household.setCategory(Long.parseLong(req.getParameter("expendcategoryList")));
			}catch(Exception e){
				logger().error("error - "+e.toString());
				dao.TransactionRollBack();
				throw e;
			}
		}else{
			logger().error("money typeが合わないです。");
			dao.TransactionRollBack();
			throw new Exception("money typeが合わないです。");
		}
		try{
			int year = Integer.parseInt(req.getParameter("year"));
			int month = Integer.parseInt(req.getParameter("month"));
			int day = Integer.parseInt(req.getParameter("day"));
			SimpleDateFormat s = new SimpleDateFormat("yyyy-MM-dd");
			Date householdDate = s.parse(String.format("%04d-%02d-%02d",year,month,day));
			entity.setHouseholddate(householdDate);
			setCookie("date",String.format("%04d-%02d",year,month) ,365*24*60*60);
		}catch(Exception e){
			logger().error("date変換中でエラーが発生しました。");
			throw e;
		}
		if(entity.getCategory() == null){
			entity.setCategory(0L);
		}
		entity.setMoneytype(household.getMoneytype());
		entity.setCategory(household.getCategory());
		entity.setContents(household.getContents());
		entity.setMoney(household.getMoney());
		entity.setOther(household.getOther());
		entity.setCreater(getUerInfoSession().getUserid());
		entity.setCreatedate(new Date());
		try{
			dao.update(entity);
			dao.TransactionCommit();
		}catch(Exception e){
			dao.TransactionRollBack();
			logger().error("家計簿入力エラー");
			throw e;
		}
		return "redirect:main.html";
	}
	protected Household copyEntity(Household original){
		Household ret = new Household();
		ret.setIdx(null);
		ret.setHouseholddate(original.getHouseholddate());
		ret.setMoneytype(original.getMoneytype());
		ret.setCategory(original.getCategory());
		ret.setContents(original.getContents());
		ret.setMoney(original.getMoney());
		ret.setOther(original.getOther());
		ret.setCreater(original.getCreater());
		ret.setCreatedate(original.getCreatedate());
		ret.setHouseholdtype(original.getHouseholdtype());
		ret.setState(original.getState());
		return ret;
	}
	@RequestMapping(value="/mobile/deleteform.html",method=RequestMethod.POST)
	public String DeleteForm(ModelMap modelmap,HttpSession session,HttpServletRequest req,HttpServletResponse res,Household household)
		throws Exception{
		initSession(modelmap,session,req,res);
		logger().info("Mobile Delete Page Submit!");
		logger().info("household Type - " + getUerInfoSession().getHouseholdtype());

		HouseholdDao dao = new HouseholdDao();
		Household entity = dao.findByPk(household.getIdx());
		if(!getUerInfoSession().getHouseholdtype().equals(entity.getHouseholdtype())){
			throw new Exception("household type 間違い");
		}
		entity.setState("1");
		try{
			dao.TransactionBegin();
			dao.update(entity);
			dao.TransactionCommit();
		}catch(Exception e){
			dao.TransactionRollBack();
			logger().error("家計簿入力エラー");
			throw e;
		}
		return "redirect:main.html";
	}
}
