package kr.pe.nowonbun.household2.mobile;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import javax.websocket.EncodeException;

import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

import kr.pe.nowonbun.household2.bean.Household_Category;
import kr.pe.nowonbun.household2.common.HAjaxController;
import kr.pe.nowonbun.household2.common.HWSParams;
import kr.pe.nowonbun.household2.dao.CategoryDao;
import kr.pe.nowonbun.household2.dao.HouseholdDao;
import kr.pe.nowonbun.household2.entity.Category;
import kr.pe.nowonbun.household2.entity.Household;

@Controller
public class HMListMobileSearch extends HAjaxController{

	@Override
	protected Class<?> setLogclass() {
		return HMListMobileSearch.class;
	}
	@RequestMapping(value="/mobile/listMobileSearch.html",method=RequestMethod.POST)
	@ResponseBody
	public String ListSearch(ModelMap modelmap,HttpSession session,HttpServletRequest req,HttpServletResponse res,String message)
		throws Exception{
		initSession(modelmap,session,req,res);
		HWSParams input = decode(message);
		SimpleDateFormat s = new SimpleDateFormat("yyyy-MM");
		if("search".equals(input.getFunc())){
			HouseholdDao householddao = new HouseholdDao();
			Calendar c = Calendar.getInstance();
			c.setTime(s.parse(input.getData().toString()));
			Calendar c1 = Calendar.getInstance();
			Calendar c2 = Calendar.getInstance();
			
			c1.clear();
			c2.clear();
			
			c1.set(Calendar.YEAR,c.get(Calendar.YEAR));
			c1.set(Calendar.MONTH,c.get(Calendar.MONTH));
			c1.set(Calendar.DATE, 1);
		
			c2.set(Calendar.YEAR,c.get(Calendar.YEAR));
			c2.set(Calendar.MONTH,c.get(Calendar.MONTH));
			c2.set(Calendar.DATE, 1);
			c2.add(Calendar.MONTH, 1);
			c2.add(Calendar.DATE, -1);
			
			logger().info("household Type - " + getUerInfoSession().getHouseholdtype());
			logger().info("startDate - " + c1.getTime());
			logger().info("endDate - " + c2.getTime());
			List<Household> list = null;
			try{
				list = householddao.findList(new Object[]{
										HouseholdDao.DEFAULTLIST,
										getUerInfoSession().getHouseholdtype(),
										c1.getTime(),
										c2.getTime()});
				logger().info("Search count - "+list.size());
			}catch(Exception e){
				logger().error("household list Searching error!");
				throw e;
			}
			try{
				setReturnFunc(input.getFunc());
				setReturnData(list);
				return encode(getReturnParams());
			}catch(EncodeException e){
				logger().error("send Error Exception - " + e);
				throw e;
			}
		}else if("searchDay".equals(input.getFunc())){
			HouseholdDao householddao = new HouseholdDao();
			Calendar c = Calendar.getInstance();
			c.setTime(s.parse(input.getData().toString()));
			Calendar c1 = Calendar.getInstance();
			Calendar c2 = Calendar.getInstance();
			
			c1.clear();
			c2.clear();
			
			c1.set(Calendar.YEAR,c.get(Calendar.YEAR));
			c1.set(Calendar.MONTH,c.get(Calendar.MONTH));
			c1.set(Calendar.DATE, 1);
		
			c2.set(Calendar.YEAR,c.get(Calendar.YEAR));
			c2.set(Calendar.MONTH,c.get(Calendar.MONTH));
			c2.set(Calendar.DATE, 1);
			c2.add(Calendar.MONTH, 1);
			c2.add(Calendar.DATE, -1);
			
			logger().info("household Type - " + getUerInfoSession().getHouseholdtype());
			logger().info("startDate - " + c1.getTime());
			logger().info("endDate - " + c2.getTime());
			List<Household> list = null;
			try{
				list = householddao.findList(new Object[]{
										HouseholdDao.DAYORDERLIST,
										getUerInfoSession().getHouseholdtype(),
										c1.getTime(),
										c2.getTime()});
				logger().info("Search count - "+list.size());
			}catch(Exception e){
				logger().error("household list Searching error!");
				throw e;
			}
			try{
				setReturnFunc(input.getFunc());
				setReturnData(list);
				return encode(getReturnParams());
			}catch(EncodeException e){
				logger().error("send Error Exception - " + e);
				throw e;
			}
		}else if("searchCategory".equals(input.getFunc())){
			HouseholdDao householddao = new HouseholdDao();
			CategoryDao categorydao = new CategoryDao();
			Calendar c = Calendar.getInstance();
			c.setTime(s.parse(input.getData().toString()));
			Calendar c1 = Calendar.getInstance();
			Calendar c2 = Calendar.getInstance();
			
			c1.clear();
			c2.clear();
			
			c1.set(Calendar.YEAR,c.get(Calendar.YEAR));
			c1.set(Calendar.MONTH,c.get(Calendar.MONTH));
			c1.set(Calendar.DATE, 1);
		
			c2.set(Calendar.YEAR,c.get(Calendar.YEAR));
			c2.set(Calendar.MONTH,c.get(Calendar.MONTH));
			c2.set(Calendar.DATE, 1);
			c2.add(Calendar.MONTH, 1);
			c2.add(Calendar.DATE, -1);
			
			logger().info("household Type - " + getUerInfoSession().getHouseholdtype());
			logger().info("startDate - " + c1.getTime());
			logger().info("endDate - " + c2.getTime());
			List<Household> list = null;
			List<Category> categorylist = null;
			try{
				list = householddao.findList(new Object[]{
										HouseholdDao.CATGORYLIST,
										getUerInfoSession().getHouseholdtype(),
										c1.getTime(),
										c2.getTime()});
				categorylist = categorydao.findList(new Object[]{
										CategoryDao.ALLLIST,
										getUerInfoSession().getHouseholdtype()});
				logger().info("Search count - "+list.size());
			}catch(Exception e){
				logger().error("household list Searching error!");
				throw e;
			}
			List<Household_Category> list2 = new ArrayList<Household_Category>();
			for (Household item : list) {
				Household_Category data = new Household_Category();
				data.setData(item);
				if(data.getCategory() != null){
					for(Category item2 : categorylist){
						if(item2.getIdx().equals(data.getCategory().intValue())){
							data.setCategoryname(item2.getCategoryname());
							data.setCategorystate(item2.getState());
							break;
						}
				}
				}
				list2.add(data);
			}
			try{
				setReturnFunc(input.getFunc());
				//setReturnData(list);
				setReturnData(list2);
				return encode(getReturnParams());
			}catch(EncodeException e){
				logger().error("send Error Exception - " + e);
				throw e;
			}
		}
		
		throw new Exception("message funcname wrong!");
	}
}
