package kr.pe.nowonbun.household2.mobile;

import java.util.Calendar;
import java.util.HashMap;

import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

import com.fasterxml.jackson.databind.ObjectMapper;

import kr.pe.nowonbun.household2.common.HController;
import kr.pe.nowonbun.household2.dao.SessionDao;
import kr.pe.nowonbun.household2.dao.UsertableDao;
import kr.pe.nowonbun.household2.entity.Session;
import kr.pe.nowonbun.household2.entity.Usertable;

@Controller
public class HMLogin extends HController {

	@Override
	protected Class<?> setLogclass() {
		return HMLogin.class;
	}
	@RequestMapping(value="/mobile/login.html",method=RequestMethod.GET)
	public String LoginIndex(ModelMap modelmap,HttpSession session,HttpServletRequest req,HttpServletResponse res){
		logger().info("Mobile browser's login page is opening.");
		initSession(modelmap,session,req,res);
		if(getUerInfoSession() != null){
			logger().info("session is lived. id - " + getUerInfoSession().getUserid());
			createConnectLog(getUerInfoSession().getUserid());
			Calendar c = Calendar.getInstance();
			setCookie("date",String.format("%04d-%02d", c.get(Calendar.YEAR),c.get(Calendar.MONTH)+1),365*24*60*60);
			return "redirect:main.html";
		}
		Cookie[] cookies = req.getCookies();
		for(Cookie cookie : cookies){
			if("cookieLoginInfo".equals(cookie.getName())){
				ObjectMapper mapper = new ObjectMapper();
				try {
					HashMap<String,String> logininfo = mapper.readValue(cookie.getValue(),HashMap.class);
					SessionDao sdao = new SessionDao();
					Session ses = sdao.findByPk(logininfo.get("userid"));
					if(ses != null){
						if(ses.getSessionkey() != null && ses.getSessionkey().equals(logininfo.get("passSession"))){
							UsertableDao dao = new UsertableDao();
							Usertable entity = dao.findByPk(logininfo.get("userid"));
							setUserInfoSession(entity);
							logger().info("session is lived. id - " + getUerInfoSession().getUserid());
							createConnectLog(getUerInfoSession().getUserid());
							Calendar c = Calendar.getInstance();
							setCookie("date",String.format("%04d-%02d", c.get(Calendar.YEAR),c.get(Calendar.MONTH)+1),365*24*60*60);
							return "redirect:main.html";
						}
					}
				} catch (Exception e){
					logger().error("クッキー取得中でエラーが発生しました。 e - "+e.toString());
				}
			}
		}
		return "/mobile/login";
	}
	@RequestMapping(value="/mobile/login.html",method=RequestMethod.POST)
	public String LoginSubmit(ModelMap modelmap,HttpSession session,HttpServletRequest req,HttpServletResponse res,Usertable usertable){
		logger().info("Mobile browser's login authentication is starting.");
		initSession(modelmap,session,req,res);
		UsertableDao dao = new UsertableDao();
		String userid = usertable.getUserid();
		logger().info("Mobile browser's login ID - "+userid);
		usertable = dao.passwordCheck(usertable);
		if(usertable != null){
			String checked = req.getParameter("logincookiecheck");
			if("1".equals(checked)){
				SessionDao sdao = new SessionDao();
				try{
					Session ses = sdao.findByPk(userid);
					if(ses == null){
						ses = new Session();
						ses.setUserid(userid);
					}
					ses.setSessionkey(req.getSession().getId());
					sdao.TransactionBegin();
					sdao.update(ses);
					
					HashMap<String,String> logininfo = new HashMap<String,String>();
					logininfo.put("userid", userid);
					logininfo.put("passSession", req.getSession().getId());
					ObjectMapper mapper = new ObjectMapper();
					setCookie("cookieLoginInfo",mapper.writeValueAsString(logininfo),365*24*60*60);
					sdao.TransactionCommit();
				}catch(Exception e){
					logger().error("クッキー焼く中でエラーが発生しました。e - "+ e.toString());
					sdao.TransactionRollBack();
				}
			}
			logger().info("Web browser's login OK.");
			setUserInfoSession(usertable);
			createConnectLog(userid);
			Calendar c = Calendar.getInstance();
			setCookie("date",String.format("%04d-%02d", c.get(Calendar.YEAR),c.get(Calendar.MONTH)+1),365*24*60*60);
			return "redirect:main.html";
		}else{
			logger().info("Mobile browser's login NG.");
			modelmap.addAttribute("userid", userid);
			modelmap.addAttribute("errorMsg", "IDまたはパスワードをご確認してください。");
			return "/mobile/login";
		}
	}
	@RequestMapping(value="/mobile/logout.html")
	public String Logout(ModelMap modelmap,HttpSession session,HttpServletRequest req,HttpServletResponse res){
		logger().info("Mobile browser's logout. ID - "+getUerInfoSession().getUserid());
		initSession(modelmap,session,req,res);
		getSession().invalidate();
		setCookie("cookieLoginInfo",null,0);
		return "redirect:login.html";
	}
}
