package kr.pe.nowonbun.household2.mobile;

import java.util.Calendar;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.RequestMapping;

import kr.pe.nowonbun.household2.common.HController;
import kr.pe.nowonbun.household2.dao.CategoryDao;
import kr.pe.nowonbun.household2.entity.Category;

@Controller
public class HMMain extends HController {

	@Override
	protected Class<?> setLogclass() {
		return HMMain.class;
	}
	@RequestMapping(value="/mobile/main.html")
	public String MainIndex(ModelMap modelmap,HttpSession session,HttpServletRequest req,HttpServletResponse res)
		throws Exception{
		initSession(modelmap,session,req,res);
		logger().info("Mobile Main Page Open!");
		logger().info("household Type - " + getUerInfoSession().getHouseholdtype());
		
		String year = req.getParameter("year");
		String month = req.getParameter("month");
		if(year != null && month != null){
			try{
				int nYear = Integer.parseInt(year);
				int nMonth = Integer.parseInt(month);
				
				if(!(nYear >= 2014 && nYear <= 2020)){
					throw new Exception("year data Error Year Result - "+year);
				}
				if(!(nMonth >= 1 && nMonth <= 12)){
					throw new Exception("month data Error Year Result - "+month);
				}
			}catch(Exception e){
				logger().error("parameter Error - "  + e.toString());
				Calendar c = Calendar.getInstance();
				int nYear = c.get(Calendar.YEAR);
				int nMonth = c.get(Calendar.MONTH) + 1;
				year = String.format("%04d", nYear);
				month = String.format("%02d", nMonth);
			}
		}else{
			Calendar c = Calendar.getInstance();
			int nYear = c.get(Calendar.YEAR);
			int nMonth = c.get(Calendar.MONTH) + 1;
			year = String.format("%04d", nYear);
			month = String.format("%02d", nMonth);
		}
		
		modelmap.addAttribute("year", year);
		modelmap.addAttribute("month", month);
		
		//CategoryDao dao = new CategoryDao();
		//List<Category> categorylist = dao.findList(new Object[]{	CategoryDao.DEFAULTLIST,
		//												getUerInfoSession().getHouseholdtype()});
		
		//modelmap.addAttribute("categorylist",categorylist);
		return "/mobile/main";
	}
}
