package kr.pe.nowonbun.household2.mobile;

import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.List;

import javax.websocket.CloseReason;
import javax.websocket.EncodeException;
import javax.websocket.EndpointConfig;
import javax.websocket.OnClose;
import javax.websocket.OnError;
import javax.websocket.OnMessage;
import javax.websocket.OnOpen;
import javax.websocket.Session;
import javax.websocket.server.ServerEndpoint;

import kr.pe.nowonbun.household2.common.HConfigurator;
import kr.pe.nowonbun.household2.common.HWSParams;
import kr.pe.nowonbun.household2.common.HWSParamsDecoder;
import kr.pe.nowonbun.household2.common.HWSParamsEncoder;
import kr.pe.nowonbun.household2.common.HWebsocket;
import kr.pe.nowonbun.household2.dao.HouseholdDao;
import kr.pe.nowonbun.household2.entity.Household;

@ServerEndpoint(	value="/ws/listMobileSearch.ws",
					decoders = { HWSParamsDecoder.class },
					encoders = { HWSParamsEncoder.class },
					configurator = HConfigurator.class)
public class HMWList extends HWebsocket{
	@Override
	protected Class<?> setLogclass() {
		return HMWList.class;
	}
	@OnOpen
	public void handleOpen(Session session, EndpointConfig conf) {
		setSocketSession(session);
		setHttpSession(conf);
	}
	@OnMessage
	public void handleMessage(Session session, HWSParams input) 
			throws EncodeException,IOException,Exception{
		setSocketSession(session);
		SimpleDateFormat s = new SimpleDateFormat("yyyy-MM");
		if("search".equals(input.getFunc())){
			HouseholdDao householddao = new HouseholdDao();
			Calendar c = Calendar.getInstance();
			c.setTime(s.parse(input.getData().toString()));
			Calendar c1 = Calendar.getInstance();
			Calendar c2 = Calendar.getInstance();
			
			c1.clear();
			c2.clear();
			
			c1.set(Calendar.YEAR,c.get(Calendar.YEAR));
			c1.set(Calendar.MONTH,c.get(Calendar.MONTH));
			c1.set(Calendar.DATE, 1);
		
			c2.set(Calendar.YEAR,c.get(Calendar.YEAR));
			c2.set(Calendar.MONTH,c.get(Calendar.MONTH));
			c2.set(Calendar.DATE, 1);
			c2.add(Calendar.MONTH, 1);
			c2.add(Calendar.DATE, -1);
			
			logger().info("household Type - " + getUerInfoSession().getHouseholdtype());
			logger().info("startDate - " + c1.getTime());
			logger().info("endDate - " + c2.getTime());
			List<Household> list = null;
			try{
				list = householddao.findList(new Object[]{
										HouseholdDao.DEFAULTLIST,
										getUerInfoSession().getHouseholdtype(),
										c1.getTime(),
										c2.getTime()});
				logger().info("Search count - "+list.size());
			}catch(Exception e){
				logger().error("household list Searching error!");
				throw e;
			}
			try{
				sendMessage(input.getFunc(), list);
			}catch(EncodeException e){
				logger().error("send Error Exception - " + e);
				throw e;
			}catch(IOException e){
				logger().error("send Error Exception - " + e);
				throw e;
			}
		}else if("searchDay".equals(input.getFunc())){
			HouseholdDao householddao = new HouseholdDao();
			Calendar c = Calendar.getInstance();
			c.setTime(s.parse(input.getData().toString()));
			Calendar c1 = Calendar.getInstance();
			Calendar c2 = Calendar.getInstance();
			
			c1.clear();
			c2.clear();
			
			c1.set(Calendar.YEAR,c.get(Calendar.YEAR));
			c1.set(Calendar.MONTH,c.get(Calendar.MONTH));
			c1.set(Calendar.DATE, 1);
		
			c2.set(Calendar.YEAR,c.get(Calendar.YEAR));
			c2.set(Calendar.MONTH,c.get(Calendar.MONTH));
			c2.set(Calendar.DATE, 1);
			c2.add(Calendar.MONTH, 1);
			c2.add(Calendar.DATE, -1);
			
			logger().info("household Type - " + getUerInfoSession().getHouseholdtype());
			logger().info("startDate - " + c1.getTime());
			logger().info("endDate - " + c2.getTime());
			List<Household> list = null;
			try{
				list = householddao.findList(new Object[]{
										HouseholdDao.DAYORDERLIST,
										getUerInfoSession().getHouseholdtype(),
										c1.getTime(),
										c2.getTime()});
				logger().info("Search count - "+list.size());
			}catch(Exception e){
				logger().error("household list Searching error!");
				throw e;
			}
			try{
				sendMessage(input.getFunc(), list);
			}catch(EncodeException e){
				logger().error("send Error Exception - " + e);
				throw e;
			}catch(IOException e){
				logger().error("send Error Exception - " + e);
				throw e;
			}
		}else if("searchCategory".equals(input.getFunc())){
			HouseholdDao householddao = new HouseholdDao();
			Calendar c = Calendar.getInstance();
			c.setTime(s.parse(input.getData().toString()));
			Calendar c1 = Calendar.getInstance();
			Calendar c2 = Calendar.getInstance();
			
			c1.clear();
			c2.clear();
			
			c1.set(Calendar.YEAR,c.get(Calendar.YEAR));
			c1.set(Calendar.MONTH,c.get(Calendar.MONTH));
			c1.set(Calendar.DATE, 1);
		
			c2.set(Calendar.YEAR,c.get(Calendar.YEAR));
			c2.set(Calendar.MONTH,c.get(Calendar.MONTH));
			c2.set(Calendar.DATE, 1);
			c2.add(Calendar.MONTH, 1);
			c2.add(Calendar.DATE, -1);
			
			logger().info("household Type - " + getUerInfoSession().getHouseholdtype());
			logger().info("startDate - " + c1.getTime());
			logger().info("endDate - " + c2.getTime());
			List<Household> list = null;
			try{
				list = householddao.findList(new Object[]{
										HouseholdDao.CATGORYLIST,
										getUerInfoSession().getHouseholdtype(),
										c1.getTime(),
										c2.getTime()});
				logger().info("Search count - "+list.size());
			}catch(Exception e){
				logger().error("household list Searching error!");
				throw e;
			}
			try{
				sendMessage(input.getFunc(), list);
			}catch(EncodeException e){
				logger().error("send Error Exception - " + e);
				throw e;
			}catch(IOException e){
				logger().error("send Error Exception - " + e);
				throw e;
			}
		}
	}
	@OnClose
	public void handleClose(Session session, CloseReason reason) {
		setSocketSession(session);
		System.out.println("close");
	}
	@OnError
	public void handleError(Session session, Throwable error) {
		setSocketSession(session);
		System.out.println("error");
	}
}
