<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<!DOCTYPE>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<jsp:include page="../common/mobileHeader.jsp" />
<link href="../css/mobile/categoryinsert.css" type="text/css" rel="stylesheet" />
<script type="text/javascript" src="../js/mobile/categoryinsert.js"></script>
</head>
<body>
	<div data-role="page">
		<jsp:include page="menu2.jsp"></jsp:include>
		<div role="main" class="ui-content">
			<div id="errorMsg"><span></span></div>
			<div id="main">
				<form method="POST" data-ajax="false">
					<c:if test="${categoryitem != null}">
						<input type="hidden" name="idx" id="idx" value="${categoryitem.idx}" />
					</c:if>
					<c:if test="${categoryitem == null}">
						<input type="hidden" name="idx" id="idx" value="0" />
					</c:if>
					<table>
						<thead>
							<tr>
								<th colspan="2"><label>カテゴリ追加</label></th>
							</tr>
						</thead>
						<tbody>
							<tr>
								<td style="width: 15%;"><label>区分</label></td>
								<td>
									<c:if test="${categoryitem == null}">
										<select data-mini="true" name="moneytype">
											<option value="1" >収入</option>
											<option value="2" selected>支出</option>
										</select>
									</c:if>
									<c:if test="${categoryitem != null}">
										<select data-mini="true" name="moneytype">
											<c:if test="${categoryitem.moneytype == 1}">
												<option value="1" selected>収入</option>
												<option value="2">支出</option>
											</c:if>
											<c:if test="${categoryitem.moneytype == 2}">
												<option value="1">収入</option>
												<option value="2" selected>支出</option>
											</c:if>
										</select>
									</c:if>
								</td>
							</tr>
							<tr>
								<td style="width: 15%;"><label>内容</label></td>
								<td><input type="text" name="categoryname" value="${categoryitem.categoryname}"/></td>
							</tr>
						</tbody>
					</table>
				</form>
			</div>
			<div style="text-align: center;">
			 	<c:if test="${categoryitem == null}">
					<button class="ui-btn ui-corner-all ui-btn-inline ui-btn ui-mini" onclick="$('#ApplyDialog').popup('open');">登録</button>
					<button class="ui-btn ui-corner-all ui-btn-inline ui-btn ui-mini" onclick="categoryForm();">取消</button>
					<div id="ApplyDialog" style="max-width: 400px;" data-role="popup" data-theme="b" data-overlay-theme="b" data-dismissible="false">
			          <div class="ui-content" role="main">
			              <h3 class="ui-title">登録しますか？</h3>
			              <a class="ui-btn ui-corner-all ui-shadow ui-btn-inline ui-btn-b" href="#" data-rel="back">Cancel</a>
			              <a class="ui-btn ui-corner-all ui-shadow ui-btn-inline ui-btn-b" href="#" data-transition="flow" onclick="applyCategory();">登録</a>
			          </div>
			      </div>
				</c:if>
				<c:if test="${categoryitem != null}">
					<button class="ui-btn ui-corner-all ui-btn-inline ui-btn ui-mini" onclick="$('#ModifyDialog').popup('open');">修正</button>
		          <button class="ui-btn ui-corner-all ui-btn-inline ui-btn ui-mini" onclick="$('#DeleteDialog').popup('open');">削除</button>
		          <button class="ui-btn ui-corner-all ui-btn-inline ui-btn ui-mini" onclick="categoryForm();">取消</button>
		          <div id="ModifyDialog" style="max-width: 400px;" data-role="popup" data-theme="b" data-overlay-theme="b" data-dismissible="false">
			          <div class="ui-content" role="main">
			              <h3 class="ui-title">修正しますか？</h3>
			              <a class="ui-btn ui-corner-all ui-shadow ui-btn-inline ui-btn-b" href="#" data-rel="back">Cancel</a>
			              <a class="ui-btn ui-corner-all ui-shadow ui-btn-inline ui-btn-b" href="#" data-transition="flow" onclick="modifyCategory();">修正</a>
			          </div>
			      </div>
			      <div id="DeleteDialog" style="max-width: 400px;" data-role="popup" data-theme="b" data-overlay-theme="b" data-dismissible="false">
			          <div class="ui-content" role="main">
			              <h3 class="ui-title">削除しますか？</h3>
			              <a class="ui-btn ui-corner-all ui-shadow ui-btn-inline ui-btn-b" href="#" data-rel="back">Cancel</a>
			              <a class="ui-btn ui-corner-all ui-shadow ui-btn-inline ui-btn-b" href="#" data-transition="flow" onclick="deleteCategory()">削除</a>
			          </div>
			      </div>
				</c:if>
			</div>
		</div>
	</div>
</body>
</html>

