<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<!DOCTYPE>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<jsp:include page="../common/mobileHeader.jsp" />
	<link href="../css/mobile/insertForm.css" type="text/css" rel="stylesheet" />
	<script type="text/javascript" src="../js/mobile/insertForm.js"></script>
	<script type="text/javascript" src="../js/mobile/calculator.js"></script>
</head>
<body>
	<div data-role="page">
		<jsp:include page="menu2.jsp"></jsp:include>
		<div role="main" class="ui-content">
			<div id="errorMsg"><span></span></div>
			<div id="main">
				<form method="POST" data-ajax="false">
					<c:if test="${household == null}">
						<input type="hidden" name="idx" id="Index" value="0" />
					</c:if>
					<c:if test="${household != null}">
						<input type="hidden" name="idx" id="Index" value="${household.idx}" />
					</c:if>
					<table>
						<thead>
							<tr>
								<th colspan="2">
									<label>新規</label>
								</th>
							</tr>
						</thead>
						<tbody>
							<tr>
								<td><label>日付</label></td>
								<td>
									<fieldset data-role="controlgroup" data-type="horizontal">
										<select name="year" id="year" data-inline="true" style="display: inline;" data-mini="true">
											<option value="2014">2014 年</option>
											<option value="2015">2015 年</option>
											<option value="2016">2016 年</option>
										</select> 
										<select name="month" id="month" data-inline="true" style="display: inline;" data-mini="true">
											<option value="1">1 月</option>
											<option value="2">2 月</option>
											<option value="3">3 月</option>
											<option value="4">4 月</option>
											<option value="5">5 月</option>
											<option value="6">6 月</option>
											<option value="7">7 月</option>
											<option value="8">8 月</option>
											<option value="9">9 月</option>
											<option value="10">10 月</option>
											<option value="11">11 月</option>
											<option value="12">12 月</option>
										</select> 
										<select name="day" id="day" data-mini="true" data-inline="true" style="display: inline;">
											<option value="1">1 日</option>
											<option value="2">2 日</option>
											<option value="3">3 日</option>
											<option value="4">4 日</option>
											<option value="5">5 日</option>
											<option value="6">6 日</option>
											<option value="7">7 日</option>
											<option value="8">8 日</option>
											<option value="9">9 日</option>
											<option value="10">10 日</option>
											<option value="11">11 日</option>
											<option value="12">12 日</option>
											<option value="13">13 日</option>
											<option value="14">14 日</option>
											<option value="15">15 日</option>
											<option value="16">16 日</option>
											<option value="17">17 日</option>
											<option value="18">18 日</option>
											<option value="19">19 日</option>
											<option value="20">20 日</option>
											<option value="21">21 日</option>
											<option value="22">22 日</option>
											<option value="23">23 日</option>
											<option value="24">24 日</option>
											<option value="25">25 日</option>
											<option value="26">26 日</option>
											<option value="27">27 日</option>
											<option value="28">28 日</option>
											<option value="29">29 日</option>
											<option value="30">30 日</option>
											<option value="31">31 日</option>
										</select>
									</fieldset>
									<input type="hidden" id="yearD" value="${year}">
									<input type="hidden" id="monthD" value="${month}">
									<input type="hidden" id="dayD" value="${day}">
								</td>
							</tr>
							<tr>
								<td><label>区分</label></td>
								<td>
									<select data-mini="true" name="moneytype" id="selectType" onchange="categoryView();">
										<option value="1" ${household.moneytype == '1'?'selected':''}>収入</option>
										<option value="2" ${household == null || household.moneytype == '2'?'selected':''}>支出</option>
									</select>
								</td>
							</tr>
							<tr>
								<td><label>カテ</label></td>
								<td>
									<div id="incomecategoryListDiv">
										<select data-mini="true" name="incomecategoryList" id="incomecategoryList">
											<option value="0">選択無し</option>
											<c:forEach items="${incomeCategory}" var="category">
												<c:if test="${category.state == 0}">
											    	<option value="${category.idx}" ${household.category==category.idx?'selected':'' }>${category.categoryname}</option>
											   </c:if>
											   <c:if test="${category.state == 1 && household.category==category.idx}">
											   		<option value="${category.idx}" selected>${category.categoryname}</option>
											   		<script>$(function(){selectedEnable('incomecategoryList')});</script>
											   </c:if>
											</c:forEach>
										</select>
									</div>
									<div id="expendcategoryListDiv">
										<select data-mini="true" name="expendcategoryList" id="expendcategoryList">
											<option value="0">選択無し</option>
											<c:forEach items="${exportCategory}" var="category">
												<c:if test="${category.state == 0}">
											   		<option value="${category.idx}" ${household.category==category.idx?'selected':'' }>${category.categoryname}</option>
											   </c:if>
											   <c:if test="${category.state == 1 && household.category==category.idx}">
											   		<option value="${category.idx}" selected>${category.categoryname}</option>
											   		<script>$(function(){selectedEnable('expendcategoryList')});</script>
											   </c:if>
											</c:forEach>
										</select>
									</div>
								</td>
							</tr>
							<tr>
								<td><label>内容</label></td>
								<td><input type="text" name="contents" id="contents" value="${household.contents}"/></td>
							</tr>
							<tr>
								<td><label>金額</label></td>
								<td align="center">
									<table style="padding: 0px; width: 100%; text-align:left;">
										<tr>
											<td><input type="number" name="money" id="money" pattern="[0-9]*" value="${household.money}" /></td>
											<td>
												<a class="ui-btn ui-icon-grid ui-btn-icon-notext ui-corner-all"
													href="#popupCalcul" data-rel="popup"
													data-position-to="window" data-transition="pop" id="calc"></a>
													<div class="ui-corner-all" id="popupCalcul" data-role="popup" data-theme="a">
														<div style="padding: 10px 20px;">
															<p>
																<label id="message">0</label>
															</p>
															<div>
																<a class="ui-btn ui-corner-all ui-btn-inline ui-btn ui-mini" onclick="btnNumber(7);" style='width: 10px;'>7</a>
																<a class="ui-btn ui-corner-all ui-btn-inline ui-btn ui-mini" onclick="btnNumber(8);" style='width: 10px;'>8</a>
																<a class="ui-btn ui-corner-all ui-btn-inline ui-btn ui-mini" onclick="btnNumber(9);" style='width: 10px;'>9</a>
																<a class="ui-btn ui-corner-all ui-btn-inline ui-btn ui-mini" onclick="btnDivide();"  style='width: 10px;'>/</a>
															</div>
															<div>
																<a class="ui-btn ui-corner-all ui-btn-inline ui-btn ui-mini" onclick="btnNumber(4);" style='width: 10px;'>4</a>
																<a class="ui-btn ui-corner-all ui-btn-inline ui-btn ui-mini" onclick="btnNumber(5);" style='width: 10px;'>5</a>
																<a class="ui-btn ui-corner-all ui-btn-inline ui-btn ui-mini" onclick="btnNumber(6);" style='width: 10px;'>6</a>
																<a class="ui-btn ui-corner-all ui-btn-inline ui-btn ui-mini" onclick="btnMulti();"   style='width: 10px;'>*</a>
															</div>
															<div>
																<a class="ui-btn ui-corner-all ui-btn-inline ui-btn ui-mini" onclick="btnNumber(1);" style='width: 10px;'>1</a>
																<a class="ui-btn ui-corner-all ui-btn-inline ui-btn ui-mini" onclick="btnNumber(2);" style='width: 10px;'>2</a>
																<a class="ui-btn ui-corner-all ui-btn-inline ui-btn ui-mini" onclick="btnNumber(3);" style='width: 10px;'>3</a>
																<a class="ui-btn ui-corner-all ui-btn-inline ui-btn ui-mini" onclick="btnMinus();"   style='width: 10px;'>-</a>
															</div>
															<div>
																<a class="ui-btn ui-corner-all ui-btn-inline ui-btn ui-mini" onclick="btnNumber(0);" style='width: 62px;'>0</a>
																<a class="ui-btn ui-corner-all ui-btn-inline ui-btn ui-mini" onclick="btnEqual();"   style='width: 10px;'>=</a>
																<a class="ui-btn ui-corner-all ui-btn-inline ui-btn ui-mini" onclick="btnPlus();"    style='width: 10px;'>+</a>
															</div>
															<div>
																<a class="ui-btn ui-corner-all ui-btn-inline ui-btn ui-mini" onclick="btnClear();"  style='width: 25px;'>C</a>
																<a class="ui-btn ui-corner-all ui-btn-inline ui-btn ui-mini" onclick="btnInput();"  style='width: 25px;'>入力</a>
																<a class="ui-btn ui-corner-all ui-btn-inline ui-btn ui-mini" onclick="btnClose();"  style='width: 25px;'>取消</a>
															</div>
														</div>
													</div>
											</td>
											<td>
												<a class="ui-btn ui-icon-refresh ui-btn-icon-notext ui-corner-all"
													onClick="moneyClear()"></a>
											</td>
										</tr>
									</table>
								</td>
							</tr>
							<tr>
								<td><label>備考</label></td>
								<td><input type="text" name="other" id="other" value="${household.other}"/></td>
							</tr>
						</tbody>
					</table>
				</form>
			</div>
			<c:if test="${household == null}">
				<div style="text-align: center;">
					<button class="ui-btn ui-corner-all ui-btn-inline ui-btn ui-mini" onclick="$('#ApplyDialog').popup('open');">登録</button>
					<button class="ui-btn ui-corner-all ui-btn-inline ui-btn ui-mini" onclick="mainForm();">取消</button>
				</div>
				<div id="ApplyDialog" style="max-width: 400px;" data-role="popup" data-theme="b" data-overlay-theme="b" data-dismissible="false">
		           <div class="ui-content" role="main">
		               <h3 class="ui-title">登録しますか？</h3>
		               <a class="ui-btn ui-corner-all ui-shadow ui-btn-inline ui-btn-b" href="#" data-rel="back">Cancel</a>
		               <a class="ui-btn ui-corner-all ui-shadow ui-btn-inline ui-btn-b" href="#" data-transition="flow" onclick="Apply();">登録</a>
		           </div>
		       </div>
			</c:if>
			<c:if test="${household != null}">
				<div style="text-align: center;">
		           <button class="ui-btn ui-corner-all ui-btn-inline ui-btn ui-mini" onclick="$('#ModifyDialog').popup('open');">修正</button>
		           <button class="ui-btn ui-corner-all ui-btn-inline ui-btn ui-mini" onclick="$('#DeleteDialog').popup('open');">削除</button>
		           <button class="ui-btn ui-corner-all ui-btn-inline ui-btn ui-mini" onclick="mainForm();">取消</button>
		       </div>
		       <div id="ModifyDialog" style="max-width: 400px;" data-role="popup" data-theme="b" data-overlay-theme="b" data-dismissible="false">
		           <div class="ui-content" role="main">
		               <h3 class="ui-title">修正しますか？</h3>
		               <a class="ui-btn ui-corner-all ui-shadow ui-btn-inline ui-btn-b" href="#" data-rel="back">Cancel</a>
		               <a class="ui-btn ui-corner-all ui-shadow ui-btn-inline ui-btn-b" href="#" data-transition="flow" onclick="Modify();">修正</a>
		           </div>
		       </div>
		       <div id="DeleteDialog" style="max-width: 400px;" data-role="popup" data-theme="b" data-overlay-theme="b" data-dismissible="false">
		           <div class="ui-content" role="main">
		               <h3 class="ui-title">削除しますか？</h3>
		               <a class="ui-btn ui-corner-all ui-shadow ui-btn-inline ui-btn-b" href="#" data-rel="back">Cancel</a>
		               <a class="ui-btn ui-corner-all ui-shadow ui-btn-inline ui-btn-b" href="#" data-transition="flow" onclick="Delete()">削除</a>
		           </div>
		       </div>
	       </c:if>
		</div>
	</div>
</body>
</html>

